diff -ruN ../nakedmudv2.2/src/socials/socedit.c src/socials/socedit.c
--- ../nakedmudv2.2/src/socials/socedit.c	Thu May 12 17:08:51 2005
+++ src/socials/socedit.c	Fri May 27 01:30:57 2005
@@ -188,5 +188,5 @@
 //*****************************************************************************
 void init_socedit(void) {
   add_cmd("socedit", NULL, cmd_socedit, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE);
+	  "builder", FALSE, TRUE);
 }
diff -ruN ../nakedmudv2.2/src/socials/socials.c src/socials/socials.c
--- ../nakedmudv2.2/src/socials/socials.c	Thu May 12 17:08:51 2005
+++ src/socials/socials.c	Fri May 27 01:30:57 2005
@@ -457,16 +457,16 @@
 
   ITERATE_HASH(cmd, data, hash_i)
     add_cmd(cmd, NULL, cmd_social, 0, data->min_pos, data->max_pos, 
-	    LEVEL_PLAYER, TRUE, FALSE);
+	    "player", TRUE, FALSE);
   deleteHashIterator(hash_i);
 
   // link/unlink commands for the admins
   add_cmd("soclink", NULL, cmd_soclink, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("socunlink", NULL, cmd_socunlink, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("socials",   NULL, cmd_socials,   0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER,  TRUE, FALSE);
+	  "player",  TRUE, FALSE);
 
   // let add_social know it can start saving again
   in_social_init = FALSE;
@@ -491,7 +491,7 @@
     hashPut(social_table, cmd_list[i], social);
     // add the new command to the game
     add_cmd(cmd_list[i], NULL, cmd_social, 0, social->min_pos, social->max_pos,
-	    LEVEL_PLAYER, TRUE, FALSE);
+	    "player", TRUE, FALSE);
     free(cmd_list[i]);
   }
   free(cmd_list);
@@ -519,7 +519,7 @@
     
     // add the new command to the game
     add_cmd(new_cmd, NULL, cmd_social, 0, data->min_pos, data->max_pos,
-	    LEVEL_PLAYER, TRUE, FALSE);
+	    "player", TRUE, FALSE);
   }
 
   // save changes
diff -ruN ../nakedmudv2.2/src/socket.c src/socket.c
--- ../nakedmudv2.2/src/socket.c	Thu May 12 17:08:52 2005
+++ src/socket.c	Fri May 27 01:30:58 2005
@@ -574,11 +574,13 @@
   }
 
   /* and terminate it with the standard color */
+  /*
   if (last != -1 || underline || bold) 
   {
     output[iPtr++] =  27; output[iPtr++] = '[';
     output[iPtr++] = '0'; output[iPtr++] = 'm';
-  }
+  } 
+  */
   output[iPtr] = '\0';
 
   /* check to see if the socket can accept that much data */
diff -ruN ../nakedmudv2.2/src/time/time.c src/time/time.c
--- ../nakedmudv2.2/src/time/time.c	Thu May 12 17:08:51 2005
+++ src/time/time.c	Fri May 27 01:30:58 2005
@@ -200,7 +200,7 @@
 
   // add the time command
   add_cmd("time", NULL, cmd_time, 0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
 
   // add night descriptions for rooms
   auxiliariesInstall("time_aux_data",
diff -ruN ../nakedmudv2.2/src/utils.c src/utils.c
--- ../nakedmudv2.2/src/utils.c	Thu May 12 17:08:52 2005
+++ src/utils.c	Fri May 27 01:30:58 2005
@@ -89,10 +89,8 @@
   unequip_all(ch);
   // extract everything in the character's inventory
   OBJ_DATA *obj = NULL;
-  while( (obj = listGet(charGetInventory(ch), 0)) != NULL) {
-    obj_from_char(obj);
+  while( (obj = listGet(charGetInventory(ch), 0)) != NULL)
     extract_obj(obj);
-  }
 
   // make sure we're not attached to anything
   if(charGetFurniture(ch))
@@ -136,7 +134,7 @@
   }
 
   case COMM_LOG:
-    send_to_level(LEVEL_ADMIN, "[LOG: %s]\r\n", txt);
+    send_to_groups("admin", "[LOG: %s]\r\n", txt);
     break;
   }
 }
@@ -241,8 +239,6 @@
     return TRUE;
   if(poscmp(charGetPos(ch), POS_SLEEPING) <= 0)
     return FALSE;
-  if(charGetImmInvis(target) > charGetLevel(ch))
-    return FALSE;
 
   return TRUE;
 }
@@ -1213,19 +1209,19 @@
       break;
     else {
       char vnum_buf[20];
-      if(charGetLevel(ch) < LEVEL_BUILDER || vnum_func == NULL)
-	*vnum_buf = '\0';
-      else
+      if(vnum_func != NULL && bitIsOneSet(charGetUserGroups(ch), "builder"))
 	sprintf(vnum_buf, "[%d] ", vnum_func(things[i]));
+      else
+	*vnum_buf = '\0';
 
       if(counts[i] == 1)
-	send_to_char(ch, "%s%s\r\n", vnum_buf, desc_func(things[i]));
+	send_to_char(ch, "{g%s%s\r\n", vnum_buf, desc_func(things[i]));
       else if(multi_desc == NULL || !*multi_desc(things[i]))
-	send_to_char(ch, "%s(%d) %s\r\n", vnum_buf, 
+	send_to_char(ch, "{g%s(%d) %s\r\n", vnum_buf, 
 		     counts[i], desc_func(things[i]));
       else {
 	char fmt[SMALL_BUFFER];
-	sprintf(fmt, "%s%s\r\n", vnum_buf, multi_desc(things[i]));
+	sprintf(fmt, "{g%s%s\r\n", vnum_buf, multi_desc(things[i]));
 	send_to_char(ch, fmt, counts[i]);
       }
     }
@@ -1279,6 +1275,20 @@
   return data;
 }
 
+bool charHasMoreUserGroups(CHAR_DATA *ch1, CHAR_DATA *ch2) {
+  return (bitIsAllSet(charGetUserGroups(ch1),
+		      bitvectorGetBits(charGetUserGroups(ch2))) &&
+	  !bitIsAllSet(charGetUserGroups(ch2),
+		       bitvectorGetBits(charGetUserGroups(ch1))));
+}
+
+bool file_exists(char *fname) {
+  FILE *fl = fopen(fname, "r");
+  if(fl == NULL) return FALSE;
+  fclose(fl);
+  return TRUE;
+}
+
 void show_prompt(SOCKET_DATA *socket) {
   text_to_buffer(socket, custom_prompt(socketGetChar(socket)));
 }
@@ -1286,7 +1296,7 @@
 const char *custom_prompt(CHAR_DATA *ch) {
   static char prompt[MAX_BUFFER];
   *prompt = '\0';
-  strcat(prompt, "\r\nprompt> ");    
+  strcat(prompt, "\r\n{nprompt> ");    
   return prompt;
 }
 
diff -ruN ../nakedmudv2.2/src/utils.h src/utils.h
--- ../nakedmudv2.2/src/utils.h	Thu May 12 17:08:52 2005
+++ src/utils.h	Fri May 27 01:30:58 2005
@@ -147,9 +147,18 @@
 //*****************************************************************************
 
 //
+// returns TRUE if ch1 belongs to more user groups than ch2. By "more", we mean
+// that ch2's user groups must be a subset of ch1's
+bool charHasMoreUserGroups(CHAR_DATA *ch1, CHAR_DATA *ch2);
+
+
+//
 // a function that returns the argument passed into it
 void *identity_func(void *data);
 
+//
+// checks to see if a file exists
+bool file_exists(char *fname);
 
 // iterate across all the elements in a list
 #define ITERATE_LIST(val, it) \
diff -ruN ../nakedmudv2.2/src/zone.c src/zone.c
--- ../nakedmudv2.2/src/zone.c	Thu May 12 17:08:52 2005
+++ src/zone.c	Fri May 27 01:30:58 2005
@@ -361,9 +361,7 @@
 //
 //*****************************************************************************
 bool canEditZone(ZONE_DATA *zone, CHAR_DATA *ch) {
-  return (!charIsNPC(ch) && 
-	  (charGetLevel(ch) >= LEVEL_SCRIPTER || 
-	   is_keyword(zone->editors, charGetName(ch), FALSE)));
+  return (!charIsNPC(ch) && is_keyword(zone->editors, charGetName(ch), FALSE));
 }
 
 zone_vnum zoneGetVnum(ZONE_DATA *zone) { 
diff -ruN ../nakedmudv2.2/lib/pymodules/demo.py lib/pymodules/demo.py
--- ../nakedmudv2.2/lib/pymodules/demo.py	Wed Dec 31 17:00:00 1969
+++ lib/pymodules/demo.py	Fri May 27 01:31:05 2005
@@ -0,0 +1,46 @@
+################################################################################
+#
+# demo.py
+#
+# This is a demo module that gives the basics on how to extend the mud via
+# Python modules. Python is primarily used for scripting in NakedMud, but it is
+# only a couple small steps to integrate python and the mud enough to let Python
+# add commands, events, actions, and entirely new systems like combat and magic.
+# 
+# There are pros and cons that come with extending the mud with Python, and
+# extending the mud with C. Python is a much easier language to program in than
+# C, especially when it comes to prototyping new ideas; programming an idea in
+# Python will often take much less time than it will in C. Python code also
+# tends to be much shorter than C code, and is thus easier to maintain. Another
+# beautiful feature of the way Python is integrated into the MUD is that
+# problems in the code will rarely crash the mud. Rather, they'll just throw
+# an error that we can display, and continue working fine.
+#
+# The downside is that Python has extremely limited access to the C code that
+# serves as the foundation for NakedMud. Python can't  call any player commands
+# that are written in C (yet), Python can't add auxiliary data to the different
+# types of data in the mud (yet), and Python doesn't have the capabilities to
+# interact with some of the important C modules and systems (e.g. set_val, 
+# olc, races, bodyparts, character generation, storage sets). These are all 
+# things that will come in time, but at the moment, extending the mud in Python
+# means giving away the ability to do many things that will eventually be 
+# important.
+#
+# You won't be able to do everything with python modules, but you WILL be able
+# to do a hell of a lot... 
+#
+################################################################################
+from mud import add_cmd
+
+#
+# Our first character command added with Python! Like a normal MUD command,
+# this command takes in 4 arguments: the character who performed it, the command
+# name, a subcommand value, and the argument supplied to the command. ch is
+# a Character, cmd is a string, subcmd is an int, and arg is a string
+def cmd_pycmd(ch, cmd, subcmd, arg):
+    ch.send("Hello, " + ch.name + ". This is a demo Python command!")
+
+# let the MUD know it should add a command. This works exactly like add_cmd in 
+# the C source. Good examples of how to use it can be found in interpret.c
+add_cmd('pycmd', None, cmd_pycmd, 0, 'unconcious', 'flying', 'admin', 
+	False, False)
